#!/usr/bin/ruby -Ks
#
require '/opt/yklook/swing'
require '/opt/yklook/swingcanvas'
require '/opt/yklook/swinggraph'

class MathGraph < YKLookMain

	def yki_size()
		return [600, 370]
	end

	def yki_title()
		return 'w֐̌vZOt`'
	end

	def yki_make_display()
		funcLabel = YKLookLabel.new( "Eij{Eij" )
		tfA       = YKLookTextField.new( 5 ).yk_set_tag( 'tfA' )
		tfB       = YKLookTextField.new( 5 ).yk_set_tag( 'tfB' )
		tfC       = YKLookTextField.new( 5 ).yk_set_tag( 'tfC' )
		tfD       = YKLookTextField.new( 5 ).yk_set_tag( 'tfD' )
		btnUpdate = YKLookButton.new( "\XV" )
		cvMath    = YKLookCanvas.new( 400, 250 ).yk_set_tag( 'cvMath' )

		fon = YKLookFont.new( nil, 'B', 20 )
		funcLabel.yk_set_font( fon )
		cvMath.yk_set_back( 'white' )

		funcPan  = YKLookPanelFlow.new()
		valsPan  = YKLookPanelFlow.new()
		graphPan = YKLookPanelFlow.new()
		basePan  = YKLookPanelBox.new( 'V' )

		funcPan.yk_add( funcLabel )
		valsPan.yk_add( YKLookLabel.new( "     a:" ) )
		valsPan.yk_add( tfA )
		valsPan.yk_add( YKLookLabel.new( "     b:" ) )
		valsPan.yk_add( tfB )
		valsPan.yk_add( YKLookLabel.new( "     c:" ) )
		valsPan.yk_add( tfC )
		valsPan.yk_add( YKLookLabel.new( "     d:" ) )
		valsPan.yk_add( tfD )
		valsPan.yk_add( YKLookLabel.new( "       " ) )
		valsPan.yk_add( btnUpdate )
		graphPan.yk_add( cvMath )
		basePan.yk_add( funcPan )
		basePan.yk_add( valsPan )
		basePan.yk_add( graphPan )
		yk_add( basePan )

		tfA.yk_set_text( "3" )
		tfB.yk_set_text( "1" )
		tfC.yk_set_text( "7" )
		tfD.yk_set_text( "3" )

		fn_actionPerformed( nil )

		btnUpdate.yk_set_listener( :fn_actionPerformed );
	end

	def fn_actionPerformed( prmEvent )
		begin
			valA = fn_value( 'tfA', 'PԖ' )
			valB = fn_value( 'tfB', 'QԖ' )
			valC = fn_value( 'tfC', 'RԖ' )
			valD = fn_value( 'tfD', 'SԖ' )
			msg  = nil
		rescue => ex
			msg = ex.message()
		end
		if msg
			yk_show_dialog_message( nil, msg )
		end

		x = []
		y = []
		for idx in 0..360 do
			th = 2.0 * Math::PI * idx / 360.0
			val = valA * Math.sin(valB * th) + valC * Math.cos(valD * th)
			x << idx
			y << val
		end
		min = y.sort()[0]
		max = y.sort().reverse()[0]
		if min.abs() < max.abs()
			scale = max.abs()
		else
			scale = min.abs()
		end

		graph = yk_look( 'graph' )
		if graph
			graph.yk_clear_line_data()
		else
			graph = YKLookGraphMath.new( 400, 200 ).yk_set_tag( 'graph' )
		end
		graph.yk_set_margin( 10, 20, 20, 10 )
		graph.yk_set_x_ratio( 1, 1 )
		graph.yk_add_x_line(   0 )
		graph.yk_add_x_line( 180 )
		graph.yk_add_x_line( 360 )
		graph.yk_add_x_char(   0, '0', 85 )
		graph.yk_add_x_char( 180, '', 85 )
		graph.yk_add_x_char( 360, 'Q', 85 )
		graph.yk_set_y_attr( -scale, scale )
		graph.yk_add_line_data( 'S', [x, y] )

		mat = yk_look('cvMath')
		mat.yk_clear()
		mat.yk_draw_graph( graph, 0, 0 )
	end

	def fn_value( prm_tag, prm_pos )
		val = yk_look( prm_tag ).yk_text()
		if val =~ /\A-?[0-9]+\.?[0-9]*\z/
			return val.to_f()
		end
		raise "lw肵Ă(#{prm_pos})"
	end

	def yki_laf_is_system()
		return false
	end
	# def yki_fr_need_pack()
	#	return true
	# end
	# def yki_ht_farpath()
	#	return [ '/tools' , nil ]
	# end
end

YKLookMain.yk_mainloop( MathGraph.new() )

#
# end of program
